// -*- C++ -*-
// $Id$

/**
 * Code generated by the The ACE ORB (TAO) IDL Compiler v2.2a_p14
 * TAO and the TAO IDL Compiler have been developed by:
 *       Center for Distributed Object Computing
 *       Washington University
 *       St. Louis, MO
 *       USA
 *       http://www.cs.wustl.edu/~schmidt/doc-center.html
 * and
 *       Distributed Object Computing Laboratory
 *       University of California at Irvine
 *       Irvine, CA
 *       USA
 * and
 *       Institute for Software Integrated Systems
 *       Vanderbilt University
 *       Nashville, TN
 *       USA
 *       http://www.isis.vanderbilt.edu/
 *
 * Information about TAO is available at:
 *     http://www.cs.wustl.edu/~schmidt/TAO.html
 **/

// TAO_IDL - Generated from
// be/be_codegen.cpp:152

#ifndef _TAO_PIDL_CLIENTREQUESTINFOC_D4PZIW_H_
#define _TAO_PIDL_CLIENTREQUESTINFOC_D4PZIW_H_

#include /**/ "ace/pre.h"

#ifndef TAO_PI_SAFE_INCLUDE
#error You should not include ClientRequestInfoC.h, use tao/PI/PI.h
#endif /* TAO_PI_SAFE_INCLUDE */

#include /**/ "ace/config-all.h"

#if !defined (ACE_LACKS_PRAGMA_ONCE)
# pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */


#include /**/ "tao/PI/pi_export.h"
#include "tao/SystemException.h"
#include "tao/Basic_Types.h"
#include "tao/ORB_Constants.h"
#include "tao/Object.h"
#include "tao/AnyTypeCode/TypeCode.h"
#include "tao/AnyTypeCode/TypeCode_Constants.h"
#include "tao/AnyTypeCode/Any.h"
#include "tao/String_Manager_T.h"
#include "tao/Objref_VarOut_T.h"
#include "tao/Arg_Traits_T.h"
#include "tao/Basic_Arguments.h"
#include "tao/Special_Basic_Arguments.h"
#include "tao/Any_Insert_Policy_T.h"
#include "tao/Fixed_Size_Argument_T.h"
#include "tao/Var_Size_Argument_T.h"
#include "tao/Object_Argument_T.h"
#include /**/ "tao/Version.h"
#include /**/ "tao/Versioned_Namespace.h"

#include "tao/PI/RequestInfoC.h"
#include "tao/orb_typesC.h"
#include "tao/Policy_ForwardC.h"

#if TAO_MAJOR_VERSION != 2 || TAO_MINOR_VERSION != 2 || TAO_BETA_VERSION != 0
#error This file should be regenerated with TAO_IDL
#endif

#if defined (TAO_EXPORT_MACRO)
#undef TAO_EXPORT_MACRO
#endif
#define TAO_EXPORT_MACRO TAO_PI_Export

TAO_BEGIN_VERSIONED_NAMESPACE_DECL



// TAO_IDL - Generated from
// be/be_visitor_module/module_ch.cpp:38

namespace PortableInterceptor
{

  // TAO_IDL - Generated from
  // be/be_interface.cpp:751

#if !defined (_PORTABLEINTERCEPTOR_CLIENTREQUESTINFO__VAR_OUT_CH_)
#define _PORTABLEINTERCEPTOR_CLIENTREQUESTINFO__VAR_OUT_CH_

  class ClientRequestInfo;
  typedef ClientRequestInfo *ClientRequestInfo_ptr;

  typedef
    TAO_Objref_Var_T<
        ClientRequestInfo
      >
    ClientRequestInfo_var;
  
  typedef
    TAO_Objref_Out_T<
        ClientRequestInfo
      >
    ClientRequestInfo_out;

#endif /* end #if !defined */

  // TAO_IDL - Generated from
  // be/be_visitor_interface/interface_ch.cpp:43

  class TAO_PI_Export ClientRequestInfo
    : public virtual ::PortableInterceptor::RequestInfo
  
  {
  public:

    // TAO_IDL - Generated from
    // be/be_type.cpp:307

    typedef ClientRequestInfo_ptr _ptr_type;
    typedef ClientRequestInfo_var _var_type;
    typedef ClientRequestInfo_out _out_type;

    // The static operations.
    static ClientRequestInfo_ptr _duplicate (ClientRequestInfo_ptr obj);

    static void _tao_release (ClientRequestInfo_ptr obj);

    static ClientRequestInfo_ptr _narrow (::CORBA::Object_ptr obj);
    static ClientRequestInfo_ptr _unchecked_narrow (::CORBA::Object_ptr obj);
    static ClientRequestInfo_ptr _nil (void);

    virtual ::CORBA::Object_ptr target (
      void) = 0;

    virtual ::CORBA::Object_ptr effective_target (
      void) = 0;

    virtual ::IOP::TaggedProfile * effective_profile (
      void) = 0;

    virtual ::CORBA::Any * received_exception (
      void) = 0;

    virtual char * received_exception_id (
      void) = 0;

    virtual ::IOP::TaggedComponent * get_effective_component (
      ::IOP::ComponentId id) = 0;

    virtual ::IOP::TaggedComponentSeq * get_effective_components (
      ::IOP::ComponentId id) = 0;

    virtual ::CORBA::Policy_ptr get_request_policy (
      ::CORBA::PolicyType type) = 0;

    virtual void add_request_service_context (
      const ::IOP::ServiceContext & service_context,
      ::CORBA::Boolean replace) = 0;

    // TAO_IDL - Generated from
    // be/be_visitor_interface/interface_ch.cpp:140

    virtual ::CORBA::Boolean _is_a (const char *type_id);
    virtual const char* _interface_repository_id (void) const;
    virtual ::CORBA::Boolean marshal (TAO_OutputCDR &cdr);
  
  protected:
    // Abstract or local interface only.
    ClientRequestInfo (void);

    

    virtual ~ClientRequestInfo (void);
  
  private:
    // Private and unimplemented for concrete interfaces.
    ClientRequestInfo (const ClientRequestInfo &);

    void operator= (const ClientRequestInfo &);
  };

// TAO_IDL - Generated from
// be/be_visitor_module/module_ch.cpp:67

} // module PortableInterceptor

// TAO_IDL - Generated from
// be/be_visitor_arg_traits.cpp:68


TAO_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL


// Arg traits specializations.
namespace TAO
{
}

TAO_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_traits.cpp:62


TAO_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

// Traits specializations.
namespace TAO
{

#if !defined (_PORTABLEINTERCEPTOR_CLIENTREQUESTINFO__TRAITS_)
#define _PORTABLEINTERCEPTOR_CLIENTREQUESTINFO__TRAITS_

  template<>
  struct TAO_PI_Export Objref_Traits< ::PortableInterceptor::ClientRequestInfo>
  {
    static ::PortableInterceptor::ClientRequestInfo_ptr duplicate (
        ::PortableInterceptor::ClientRequestInfo_ptr p);
    static void release (
        ::PortableInterceptor::ClientRequestInfo_ptr p);
    static ::PortableInterceptor::ClientRequestInfo_ptr nil (void);
    static ::CORBA::Boolean marshal (
        const ::PortableInterceptor::ClientRequestInfo_ptr p,
        TAO_OutputCDR & cdr);
  };

#endif /* end #if !defined */
}
TAO_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_codegen.cpp:1703


TAO_END_VERSIONED_NAMESPACE_DECL

#include /**/ "ace/post.h"

#endif /* ifndef */

